#!/bin/sh

. ./build-env.sh

wlanfwdeb=firmware-xr829
wlanfwarch=${BSP_ARCH}
#wlanfwver=20210515
#wlanfwver=20211205
wlanfwver=20220301

mkdir -p ${wlanfwdeb}/DEBIAN
mkdir -p ${wlanfwdeb}/lib/firmware

cat <<EOFMVC > ${wlanfwdeb}/DEBIAN/control
Package: ${wlanfwdeb}
Priority: extra
Section: libs
Installed-Size: 2736
Maintainer: auto build <builder@allwinner.local>
Architecture: ${wlanfwarch}
Version: ${wlanfwver}
Depends: libc6 (>= 2.17)
Conflicts: ${wlanfwdeb}
Description: Binary firmware for Xradio XR829 wireless cards
 Binary firmware for Xradio XR829 wireless cards
EOFMVC

if [ ! -e xr829-firmware-${wlanfwver}.tar.gz ]; then
  if [ ! -e allwinner-firmware ]; then
    git clone --depth 1 https://github.com/LibreELEC/allwinner-firmware
  fi

  cd allwinner-firmware
  tar czf ../xr829-firmware-${wlanfwver}.tar.gz allwinner
  cd ..
fi

cd ${wlanfwdeb}
tar xzf ../xr829-firmware-${wlanfwver}.tar.gz
#cd ${wlanfwdeb}/lib/firmware
#tar xzf ../../../xr829-firmware-${wlanfwver}.tar.gz
cd - > /dev/null

dpkg-deb -b ${wlanfwdeb} ${wlanfwdeb}_${wlanfwver}_${wlanfwarch}.deb


wlanfwpkg=firmware-xr829
wlanfwdeb=firmware-xr829-40m
wlanfwarch=${BSP_ARCH}
wlanfwver=20220301

mkdir -p ${wlanfwdeb}/DEBIAN
mkdir -p ${wlanfwdeb}/lib/firmware

cat <<EOFMVC > ${wlanfwdeb}/DEBIAN/control
Package: ${wlanfwpkg}
Priority: extra
Section: libs
Installed-Size: 2736
Maintainer: auto build <builder@allwinner.local>
Architecture: ${wlanfwarch}
Version: ${wlanfwver}
Depends: libc6 (>= 2.17)
Conflicts: ${wlanfwpkg}
Description: Binary firmware for Xradio XR829 40M wireless cards
 Binary firmware for Xradio XR829 40M wireless cards
EOFMVC

if [ ! -e xr829-firmware-${wlanfwver}.tar.gz ]; then
  if [ ! -e allwinner-firmware ]; then
    git clone --depth 1 https://github.com/LibreELEC/allwinner-firmware
  fi

  cd allwinner-firmware
  tar czf ../xr829-firmware-${wlanfwver}.tar.gz allwinner
  cd ..
fi

cd ${wlanfwdeb}
tar xzf ../xr829-firmware-${wlanfwver}.tar.gz
#cd ${wlanfwdeb}/lib/firmware
#tar xzf ../../../xr829-firmware-${wlanfwver}.tar.gz
mv lib/firmware/fw_xr829_bt_40M.bin lib/firmware/fw_xr829_bt.bin
mv lib/firmware/sdd_xr829_40M.bin   lib/firmware/sdd_xr829.bin
cd - > /dev/null

dpkg-deb -b ${wlanfwdeb} ${wlanfwdeb}_${wlanfwver}_${wlanfwarch}.deb


wlanfwdeb=firmware-xr819s
wlanfwarch=${BSP_ARCH}
wlanfwver=20220217

mkdir -p ${wlanfwdeb}/DEBIAN
mkdir -p ${wlanfwdeb}/lib/firmware

cat <<EOFMVC > ${wlanfwdeb}/DEBIAN/control
Package: ${wlanfwdeb}
Priority: extra
Section: libs
Installed-Size: 2736
Maintainer: auto build <builder@allwinner.local>
Architecture: ${wlanfwarch}
Version: ${wlanfwver}
Depends: libc6 (>= 2.17)
Conflicts: ${wlanfwdeb}
Description: Binary firmware for Xradio XR819s wireless cards
 Binary firmware for Xradio XR819s wireless cards
EOFMVC

if [ ! -e xr819s-firmware.tar.gz ]; then
  if [ ! -e allwinner-firmware ]; then
    git clone --depth 1 https://github.com/LibreELEC/allwinner-firmware
  fi

  cd allwinner-firmware
  tar czf ../xr819s-firmware.tar.gz allwinner
  cd ..
fi

cd ${wlanfwdeb}
tar xzf ../xr819s-firmware.tar.gz
#cd ${wlanfwdeb}/lib/firmware
#tar xzf ../../../xr819s-firmware.tar.gz
cd - > /dev/null

dpkg-deb -b ${wlanfwdeb} ${wlanfwdeb}_${wlanfwver}_${wlanfwarch}.deb


wlanfwdeb=firmware-rtl8723d
wlanfwarch=${BSP_ARCH}
wlanfwver=20211223-1

mkdir -p ${wlanfwdeb}/DEBIAN
mkdir -p ${wlanfwdeb}/lib/firmware

cat <<EOFMVC > ${wlanfwdeb}/DEBIAN/control
Package: ${wlanfwdeb}
Priority: extra
Section: libs
Installed-Size: 2736
Maintainer: auto build <builder@allwinner.local>
Architecture: ${wlanfwarch}
Version: ${wlanfwver}
Depends: libc6 (>= 2.17)
Conflicts: ${wlanfwdeb}
Description: Binary firmware for Realtek RTL8723d wireless cards
 Binary firmware for Realtek RTL8723d wireless cards
EOFMVC

if [ ! -e rtl8723d-firmware.tar.gz ]; then
  if [ ! -e allwinner-firmware ]; then
    git clone --depth 1 https://github.com/LibreELEC/allwinner-firmware
  fi

  cd allwinner-firmware
  tar czf ../rtl8723d-firmware.tar.gz allwinner
  cd ..
fi

cd ${wlanfwdeb}
tar xzf ../rtl8723d-firmware.tar.gz
#cd ${wlanfwdeb}/lib/firmware
#tar xzf ../../../rtl8723d-firmware.tar.gz
cd - > /dev/null

dpkg-deb -b ${wlanfwdeb} ${wlanfwdeb}_${wlanfwver}_${wlanfwarch}.deb

