#!/bin/sh

. ./build-env.sh

lxmmmkb=`echo ${lxdebkb} | cut -d '.' -f 1-2`

export ARCH=arm64
if [ "X${BSP_ARCH}" = "Xarmhf" ]; then
  export ARCH=arm
  export CROSS_COMPILE=arm-linux-gnueabihf-

elif [ "X${BSP_ARCH}" = "Xamd64" ]; then
  export ARCH=x86
  export CROSS_COMPILE=x86_64-linux-gnu-

elif [ "X${BSP_ARCH}" = "Xi686" ]; then
  export ARCH=x86
  export CROSS_COMPILE=i686-linux-gnu-
fi

export LOCALVERSION="+${BSP_GROUP}"

defcfg=${BSP_CONFIG}_defconfig
ldcfg=${lxmmmkb}-${BSP_GROUP}.config
lxcfg=.config

lxcfg=arch/${ARCH}/configs/${defcfg}


change_lxcfg() {
  c=${lxcfg}
  if [ "x$2" = "x-" ]; then
    sed -i 's|'"$1"'||g' $c
  elif [ "x$2" = "xn" ]; then
    if grep -q -E $1'=.*' $c ; then
      sed -i 's|'$1'=.*|# '$1' is not set|g' $c
    elif ! grep -q '# '$1' is not set' $c ; then
      echo '# '$1' is not set' >> $c
    fi
  else
    if grep -q $1'='$2 $c ; then
      true
    elif grep -q -E $1'=.*' $c ; then
      sed -i 's|'$1'=.*|'$1'='$2'|g' $c
    elif grep -q '# '$1' is not set' $c ; then
      sed -i 's|# '$1' is not set|'$1'='$2'|g' $c
    else
      echo $1'='$2 >> $c
    fi
  fi
}

cd linux

#lxcfg=arch/${ARCH}/configs/defconfig
BSP_CONFIG=meson64

grep '^# CONFIG_ARCH_' ../patches/${BSP_CONFIG}_defconfig | while read c ; do
  n=`echo $c | cut -d ' ' -f 2`
  change_lxcfg $n n
done

