#!/bin/sh
malia=arm64
malim=mali450
malis=meson
maliv=r7p0

#brsub=buildroot_openlinux/buildroot/package/meson-mali
#brtgz=arm-buildroot-2016-08-18-5aaca1b35f.tar.gz
#brsub=buildroot_openlinux/buildroot/package/meson-mali
#brtgz=buildroot_openlinux_kernel_3.14_wayland_20170630.tar.gz
#brsub=buildroot_openlinux_kernel_4.9_fbdev_20180418/vendor/amlogic/meson_mali
#brtgz=buildroot_openlinux_kernel_4.9_fbdev_20180418.tar.gz
brsub=OpenLinux_20180907/vendor/amlogic/meson_mali
brtgz=buildroot_openlinux_kernel_4.9_20180907.tar.gz

if [ "X$1" = "Xarmhf" -o "X$1" = "Xarm64" ]; then
  malia=$1
fi

brarc=eabihf

if [ "${malia}" = "arm64" ]; then
  brarc=arm64
fi

if [ "X$3" = "Xmali400" -o "X$3" = "Xmali450" ]; then
  malim=$3
fi

brmal=m400
malil=meson_gx_mali_400

if [ "${malim}" = "mali450" ]; then
  brmal=m450
  malil=meson_gx_mali_450
fi

if [ "X$2" = "Xr5p1" -o "X$2" = "Xr6p1" -o "X$2" = "Xr7p0" ]; then
  maliv=$2
fi

brver=${maliv}
malix=${maliv}

if [ "${maliv:0:3}" = "r7p" ]; then
  brver=r7p0
elif [ "${maliv:0:3}" = "r6p" ]; then
  brver=r6p1
  malix=r6p2
elif [ "${maliv:0:3}" = "r5p" ]; then
  brver=r5p1
  malix=r7p0
fi

. ./build-env.sh

export ARCH=arm64
if [ "X${BSP_ARCH}" = "Xarmhf" ]; then
  export ARCH=arm
fi

defcfg=${BSP_CONFIG}_defconfig

defcfg=arch/${ARCH}/configs/${defcfg}

KDIR=$(pwd)/linux

scriptdir=`dirname $0`
cd ${scriptdir} ; scriptdir=`pwd` ; cd - > /dev/null


gitpatches() {
  if [ -e ../patches/$2 ]; then
    echo ""
    echo "Apply series patches/$2"
    echo ""

    mkdir -p patches/$1

    l=none
    for p in `cat ../patches/$2 | grep -v '^#' | grep patch` ; do
      b=`basename $p`
      d=`dirname $p`
      l=${p}
      n=`echo $b | sed s/\.patch$//g`

      if [ -e patches/${p} ]; then
        true
      elif [ -e ../patches/${p} ]; then
        cp -p ../patches/${p} patches/${p}
      else
        cp -p  ../patches/${b} patches/${p}
      fi

      echo "Apply patch patches/${p}"

      #if grep -q '\\r' patches/${p} ; then
      #  sed -i -e 's/\r$//g' patches/${p}
      #fi

     if echo $n | grep -q -E '^mali-' ; then
        if [ -e drivers/gpu/arm/mali400 ]; then
          sed -i "s|/src/devicedrv/|/drivers/gpu/arm/mali400/|g" patches/${p}
        else
          sed -i "s|/src/devicedrv/|/drivers/gpu/arm/|g" patches/${p}
        fi
      fi

      nogitcp=1
      gitcpcont=0
      nogitam=1
      gitamcont=0
      if false ; then
      if grep -m1 -q "^From ${n} Mon Sep 17 00:00:00 2001" patches/${p} ; then
        rc=0
        git cherry-pick ${n} || rc=$?
        echo "git cherry-pick ${n}: rc=${rc}"
        if [ $rc = 0 ] ; then
          nogitcp=0
          echo ${p} >> patches/series-cherry-pick
        elif [ $rc != 128 ] ; then
          #gitcpcont=1
          git cherry-pick --abort
        fi
      fi
      fi

      if [ $nogitcp = 1 -a $gitcpcont = 0 ]; then
      if grep -m1 -q "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} ; then
        c=`grep -m1 "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} | sed s/'^From '//g | cut -d ' ' -f1`

        sed -i -e "0,/^---$/ s/^---$/\n${d} ${c}\n---/" patches/${p}

        if git am --keep-cr < patches/${p} ; then
          nogitam=0
          echo ${p} >> patches/series-am
        else
          gitamcont=1
          #git am --skip
        fi
      fi
      fi

      if [ $nogitam = 1 -a $nogitcp = 1 ]; then
        pb=`echo ${p} | sed s/'\.patch$'/'-bin.patch'/g`

        #echo "Check patches/${pb}"
        if [ -e ../patches/${pb} ]; then
          cp -p ../patches/${pb} patches/${pb}
          echo git apply --stat --apply patches/${pb}
          git apply --stat --apply patches/${pb}
        fi

        if ! git apply --stat --apply patches/${p} ; then
          #git apply --stat --apply --3way patches/${p}
          #sed -i -e 's/\r$//g' patches/${p}
          patch -p1 --no-backup-if-mismatch < patches/${p}
          echo ${p} >> patches/series-no-git
        else
          echo ${p} >> patches/series-no-am
        fi
      fi

      if echo $n | grep -q -E '^linux-' ; then
        n=`echo $n | sed s/^linux-4\.1.\.y-//g`
        n=`echo $n | sed s/^linux-4\.4\.y-//g`
        n=`echo $n | sed s/^linux-4\.1.-//g`

      elif echo $n | grep -q -E '^mali-' ; then
        n=`echo $n | sed s/^mali-r.p.-//g`

      elif grep -m1 -q "^From ${n} Mon Sep 17 00:00:00 2001" patches/${p} ; then
        if ! grep -q '^---$' patches/${p} ; then
          exit 1
        fi

      else
        exit 1
      fi

      if [ $nogitam = 1 -a $nogitcp = 1 ]; then
        echo git commit -m "${d} ${n}"
        git add .
        #git commit -m "${d} ${n}"
        #echo "${d} ${n}" > patches/${p}.msg

        if grep -m1 -q "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} ; then
          if ! grep -q '^---$' patches/${p} ; then
            exit 1
          fi
          cat patches/${p} | grep -m1 -B399 '^---$' | sed /^---$/d | grep -m1 -A399 '^Subject:' | sed s/'^Subject: '/''/g > patches/${p}.msg
        else
          echo "${d} ${n}" > patches/${p}.msg
        fi
        
        if [ $gitcpcont = 1 ]; then
          git cherry-pick --continue
        elif [ $gitamcont = 1 ]; then
          git am --continue
        else
          git commit -F patches/${p}.msg
        fi
      fi

      echo ""
    done

    echo "Now in patch patches/${l}"
    cat ../patches/$2 >> patches/series

    #quilt push -a
  fi

}

applypatches() {
  gitpatches $1 $2
  #quiltpatches $1 $2
}


mkdir -p archives

cd archives

if [ ! -e ${brtgz} -a ! -e ${scriptdir}/meson-mali-lib ]; then
  #wget -N http://openlinux.amlogic.com:8000/download/ARM/filesystem/${brtgz}
  wget -N http://openlinux2.amlogic.com:8000/download/ARM/filesystem/Linux_BSP/${brtgz}
  #wget -N http://openlinux.amlogic.com:8000/download/ARM/filesystem/Linux_BSP/${brtgz}
fi

cd ..

if [ ! -e meson-mali-lib ]; then
  mkdir meson-mali-lib
  cd meson-mali-lib

  echo "Extracting meson mali lib from buildroot..."
  tar xzf ../archives/${brtgz} ${brsub}

  cd ..
fi

#if [ ! -e xf86-video-armsoc ]; then
#  git clone -b meson-drm https://github.com/superna9999/xf86-video-armsoc
#fi

if [ ! -e ${malil} ]; then
  if [ ${malix} = r6p2 ]; then
    git clone -b DX910-SW-99002-r6p1-01rel0_meson_gx https://github.com/superna9999/meson_gx_mali_450 ${malil}
  else
    git clone -b DX910-SW-99002-r7p0-00rel1_meson_gx https://github.com/superna9999/meson_gx_mali_450 ${malil}
  fi

  cd ${malil}/

  mkdir -p patches/${malix}
  for f in `cat ../patches/series-mali-${malix} | grep -E "^${malix}/" | cut -d / -f 2-` ; do
    cp -p ../patches/$f patches/${malix}/
    echo "${malix}/$f" >> patches/${malix}/series
  done

  ##patch -p1 < ../${malil}-4.14-build.patch
  #patch -p1 < ../${malil}-4.14.patch

  mkdir -p driver/patches
  #cp -p patches/*.patch driver/patches/
  cp -apP patches/${malix} driver/patches/
  mv driver/patches/${malix}/series  driver/patches/
  cd driver/
  #quilt push -a
  cd ..

else
  cd ${malil}/
fi

cp -p ../patches/mali-lib-END_USER_LICENCE_AGREEMENT.txt ./END_USER_LICENCE_AGREEMENT.txt

mkdir -p ${malia}
cd ${malia}

echo "Prepare ${brarc}/${brmal}/${brver}"

# x11

if [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}-X/${brver}/libUMP.so ]; then
  mkdir -p lib_x11-ump
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}-X/${brver}/libMali.so lib_x11-ump/
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}-X/${brver}/libUMP.so  lib_x11-ump/

elif [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}-X/libUMP.so ]; then
  mkdir -p lib_x11-ump
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}-X/libMali.so lib_x11-ump/
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}-X/libUMP.so  lib_x11-ump/

elif [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}-X/${brver}/libMali.so ]; then
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}-X/${brver}/libMali.so .

elif [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}-X/libMali.so ]; then
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}-X/libMali.so .

else
  echo "Warning: ${brmal}-X/${brver}/libMali.so not found."
fi

# wayland

if [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/wayland/drm/libMali.so ]; then
  mkdir -p lib_wayland-drm
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/wayland/drm/libMali.so lib_wayland-drm/

else
   echo "Warning: ${brmal}/${brver}/wayland/drm/libMali.so not found."
fi

if [ -e  ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/wayland/fbdev/libMali.so ]; then
  mkdir -p lib_wayland-fbdev
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/wayland/fbdev/libMali.so lib_wayland-fbdev/

elif [ -e  ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}/wayland/libMali.so ]; then
  mkdir -p lib_wayland-fbdev
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}/wayland/libMali.so lib_wayland-fbdev/

else
   echo "Warning: ${brmal}/${brver}/wayland/fbdev/libMali.so not found."
fi

# fbdev

mkdir -p lib_fbdev
if [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/fbdev/libMali.so ]; then
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/fbdev/libMali.so lib_fbdev/

elif [ -e ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}/libMali.so ]; then
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brver}/${brmal}/libMali.so lib_fbdev/

else
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/libMali.so lib_fbdev/
fi

# dummy

if [ -e  ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/dummy/libMali.so ]; then
  mkdir -p lib_dummy
  cp -p ${scriptdir}/meson-mali-lib/${brsub}/lib/${brarc}/${brmal}/${brver}/dummy/libMali.so lib_dummy/

else
   echo "Warning: ${brmal}/${brver}/dummy/libMali.so not found."
fi

cd ..

mkdir -p ${scriptdir}/meson-mali-lib/${brsub}/patches
cp -p ../patches/mali-r7p0-dev-*.patch ${scriptdir}/meson-mali-lib/${brsub}/patches/
cp -p ../patches/series-mali-r7p0-dev ${scriptdir}/meson-mali-lib/${brsub}/patches/

cd ${scriptdir}/meson-mali-lib/${brsub}/
tar czf ${malim}-${malis}-dev.tar.gz include lib/pkgconfig patches
cd - > /dev/null

mv ${scriptdir}/meson-mali-lib/${brsub}/${malim}-${malis}-dev.tar.gz ../

cd ..

if ! grep -q '!.version' ${KDIR}/.gitignore ; then
  echo '!.version' >> ${KDIR}/.gitignore
  cd ${KDIR}
  git add .gitignore
  git commit -m "exclude dot version from gitignore"
  cd - > /dev/null
fi

if [ ! -e ${KDIR}/drivers/gpu/arm/mali400 ]; then
  movegpuarm=false

  if [ -e ${KDIR}/drivers/gpu/arm/mali -a ! -e ${KDIR}/drivers/gpu/arm/mali400/mali ]; then
    mkdir -p ${KDIR}/drivers/gpu/arm/mali400

    if ! grep -q 'SPDX-License-Identifier:' ${KDIR}/drivers/gpu/arm/Kconfig ; then
      mv ${KDIR}/drivers/gpu/arm/Kconfig ${KDIR}/drivers/gpu/arm/Kconfig-org
      touch ${KDIR}/drivers/gpu/arm/Kconfig
      echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/Kconfig
      cat ${KDIR}/drivers/gpu/arm/Kconfig-org >> ${KDIR}/drivers/gpu/arm/Kconfig
      rm  ${KDIR}/drivers/gpu/arm/Kconfig-org
    fi

    if [ -e ${KDIR}/drivers/gpu/arm/Makefile -a ! -e ${KDIR}/drivers/gpu/arm/mali400/Kbuild ]; then
      touch ${KDIR}/drivers/gpu/arm/mali400/Kbuild
      if ! grep -q 'SPDX-License-Identifier:' ${KDIR}/drivers/gpu/arm/Makefile ; then
        echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
      fi
      cat ${KDIR}/drivers/gpu/arm/Makefile >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
      rm  ${KDIR}/drivers/gpu/arm/Makefile
    fi

    mv ${KDIR}/drivers/gpu/arm/mali ${KDIR}/drivers/gpu/arm/mali400/

    sed -i "s|drivers/gpu/arm/mali/Kconfig|drivers/gpu/arm/mali400/mali/Kconfig|g" ${KDIR}/drivers/gpu/arm/Kconfig
    movegpuarm=true
  fi

  if [ -e ${KDIR}/drivers/gpu/arm/ump -a ! -e ${KDIR}/drivers/gpu/arm/mali400/ump ]; then
    mkdir -p ${KDIR}/drivers/gpu/arm/mali400

    mv ${KDIR}/drivers/gpu/arm/ump ${KDIR}/drivers/gpu/arm/mali400/

    sed -i "s|drivers/gpu/arm/ump/Kconfig|drivers/gpu/arm/mali400/ump/Kconfig|g" ${KDIR}/drivers/gpu/arm/Kconfig
    movegpuarm=true
  fi

  if [ -e ${KDIR}/drivers/gpu/arm/umplock -a ! -e ${KDIR}/drivers/gpu/arm/mali400/umplock ]; then
    mkdir -p ${KDIR}/drivers/gpu/arm/mali400

    mv ${KDIR}/drivers/gpu/arm/umplock ${KDIR}/drivers/gpu/arm/mali400/
    movegpuarm=true
  fi

  if [ -e ${KDIR}/drivers/gpu/arm -a ! -e ${KDIR}/drivers/gpu/arm/Kbuild ]; then
    touch ${KDIR}/drivers/gpu/arm/Kbuild
    echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/Kbuild
    movegpuarm=true
  fi
  if [ -e ${KDIR}/drivers/gpu/arm/Kbuild ]; then
    if ! grep -q 'mali400/' ${KDIR}/drivers/gpu/arm/Kbuild ; then
      echo 'obj-y += mali400/' >> ${KDIR}/drivers/gpu/arm/Kbuild
      movegpuarm=true
    fi
  fi

  if $movegpuarm ; then
    cd ${KDIR}
    git add drivers/gpu/arm
    git commit -m "drm: move ${malim} ${malis} ${maliv}"
    cd - > /dev/null
  fi
fi

if [ -e ${KDIR}/drivers/gpu ]; then
  echo "Integrating meson mali driver..."

  if [ ! -e ${KDIR}/drivers/gpu/arm/mali400/mali -a ! -e ${KDIR}/drivers/gpu/arm/mali ]; then
    mkdir -p ${KDIR}/drivers/gpu/arm/mali400
    cp -apP ${malil}/driver/src/devicedrv/mali ${KDIR}/drivers/gpu/arm/mali400/
    cp -apP ${malil}/driver/src/devicedrv/ump ${KDIR}/drivers/gpu/arm/mali400/
    cp -apP ${malil}/driver/src/devicedrv/umplock ${KDIR}/drivers/gpu/arm/mali400/
    #cp -apP ${malil}/driver/src/ump/include ${KDIR}/drivers/gpu/arm/mali400/ump/
    cp -apP ${malil}/driver/src/ump/include/ump linux/include/

    mkdir -p ${KDIR}/patches
    cp -apP ${malil}/driver/patches/${malix} ${KDIR}/patches/
    cp -p ${malil}/driver/patches/series ${KDIR}/patches/series-mali-${malix}

    cd ${KDIR}

    git add drivers/gpu/arm
    git add include/ump
    git commit -m "drm: add ${malim} ${malis} ${maliv} driver"

    #for p in `cat patches/series-mali-${malix} | grep patch` ; do
    #  sed -i "s|/src/devicedrv/|/drivers/gpu/arm/mali400/|g" patches/${p}
    #done

    #quilt push -a
    applypatches ${malix} series-mali-${malix}

    cd - > /dev/null
  fi

  if ! grep -q CONFIG_MALI400 ${KDIR}/${defcfg} ; then
    if grep -q CONFIG_DRM_LIMA ${KDIR}/${defcfg} ; then
      sed -i s/'^CONFIG_DRM_LIMA=.*'/'# CONFIG_DRM_LIMA is not set'/g ${KDIR}/${defcfg}
    else
      cat <<EOFLIMADEFCFG | tee -a ${KDIR}/${defcfg}

# CONFIG_DRM_LIMA is not set
EOFLIMADEFCFG
    fi

    cat <<EOFMALIDEFCFG | tee -a ${KDIR}/${defcfg}

CONFIG_MALI400=m
CONFIG_MALI450=y
# CONFIG_MALI470 is not set
# CONFIG_MALI400_DEBUG is not set
# CONFIG_MALI400_PROFILING is not set
CONFIG_MALI400_UMP=y
# CONFIG_MALI_DVFS is not set
CONFIG_MALI_DMA_BUF_MAP_ON_ATTACH=y
# CONFIG_MALI_SHARED_INTERRUPTS is not set
# CONFIG_MALI_PMU_PARALLEL_POWER_UP is not set
# CONFIG_MALI_DT is not set
# CONFIG_MALI_DEVFREQ is not set
# CONFIG_MALI_QUIET is not set
EOFMALIDEFCFG

    cd ${KDIR}
    git add ${defcfg}
    git commit -m "${malia}: configs: add MALI to defconfig"
    cd - > /dev/null
  fi

  if ! grep -q CONFIG_UMP ${KDIR}/${defcfg} ; then
    cat <<EOFUMPDEFCFG | tee -a ${KDIR}/${defcfg}

CONFIG_UMP=y
# CONFIG_UMP_DEBUG is not set
EOFUMPDEFCFG

    cd ${KDIR}
    git add ${defcfg}
    git commit -m "${malia}: configs: add UMP to defconfig"
    cd - > /dev/null
  fi

  modgpuarm=false
  if grep -q CONFIG_ARCH_EXYNOS4 ${KDIR}/drivers/gpu/arm/mali400/mali/Kbuild ; then
    sed -i s/CONFIG_ARCH_EXYNOS4/CONFIG_ARCH_MESON/g ${KDIR}/drivers/gpu/arm/mali400/mali/Kbuild
    modgpuarm=true
  fi
  if grep -q exynos4 ${KDIR}/drivers/gpu/arm/mali400/mali/Kbuild ; then
    sed -i s/exynos4/meson/g ${KDIR}/drivers/gpu/arm/mali400/mali/Kbuild
    modgpuarm=true
  fi

  if [ ! -e ${KDIR}/drivers/gpu/arm/Kconfig ]; then
    touch ${KDIR}/drivers/gpu/arm/Kconfig
    echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/Kconfig
    modgpuarm=true
  fi
  if ! grep -q 'arm/mali400/mali/' ${KDIR}/drivers/gpu/arm/Kconfig ; then
    echo 'source "drivers/gpu/arm/mali400/mali/Kconfig"' >> ${KDIR}/drivers/gpu/arm/Kconfig
    modgpuarm=true
  fi
  if ! grep -q 'arm/mali400/ump/' ${KDIR}/drivers/gpu/arm/Kconfig ; then
    echo 'source "drivers/gpu/arm/mali400/ump/Kconfig"' >> ${KDIR}/drivers/gpu/arm/Kconfig
    modgpuarm=true
  fi

  if [ ! -e ${KDIR}/drivers/gpu/arm/Kbuild ]; then
    touch ${KDIR}/drivers/gpu/arm/Kbuild
    echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/Kbuild
    modgpuarm=true
  fi
  if ! grep -q 'mali400/' ${KDIR}/drivers/gpu/arm/Kbuild ; then
    echo 'obj-y += mali400/' >> ${KDIR}/drivers/gpu/arm/Kbuild
    modgpuarm=true
  fi

  if [ ! -e ${KDIR}/drivers/gpu/arm/mali400/Kbuild ]; then
    touch ${KDIR}/drivers/gpu/arm/mali400/Kbuild
    echo '# SPDX-License-Identifier: GPL-2.0' >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
    modgpuarm=true
  fi
  if ! grep -q 'mali/' ${KDIR}/drivers/gpu/arm/mali400/Kbuild ; then
    echo 'obj-$(CONFIG_MALI400) += mali/' >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
    modgpuarm=true
  fi
  if ! grep -q 'ump/' ${KDIR}/drivers/gpu/arm/mali400/Kbuild ; then
    echo 'obj-$(CONFIG_UMP) += ump/' >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
    modgpuarm=true
  fi
  if ! grep -q 'umplock/' ${KDIR}/drivers/gpu/arm/mali400/Kbuild ; then
    echo 'obj-$(CONFIG_UMP) += umplock/' >> ${KDIR}/drivers/gpu/arm/mali400/Kbuild
    modgpuarm=true
  fi

  if $modgpuarm ; then
    cd ${KDIR}
    git add drivers/gpu/arm
    git commit -m "drm: modify ${malim} ${malis} ${maliv} build"
    cd - > /dev/null
  fi

  if ! grep -q 'gpu/arm/' ${KDIR}/drivers/video/Kconfig ; then
    echo 'source "drivers/gpu/arm/Kconfig"' >> ${KDIR}/drivers/video/Kconfig

    cd ${KDIR}
    git add drivers/video/Kconfig
    git commit -m "drm: add gpu/arm to Kconfig"
    cd - > /dev/null
  fi

  if ! grep -q 'arm/' ${KDIR}/drivers/gpu/Makefile ; then
    echo 'obj-y += arm/' >> ${KDIR}/drivers/gpu/Makefile

    cd ${KDIR}
    git add drivers/gpu/Makefile
    git commit -m "drm: add gpu/arm to Makefile"
    cd - > /dev/null
  fi
fi

if [ -e ${KDIR}/drivers/gpu/arm/mali400 ]; then
  if [ ! -e ${KDIR}/drivers/gpu/arm/mali400/mali/.version ]; then
    cp -p ${malil}/driver/src/devicedrv/mali/.version ${KDIR}/drivers/gpu/arm/mali400/mali/
    cd ${KDIR}
    git add drivers/gpu/arm/mali400/mali/.version
    git commit -m "drm: add ${malim} ${malis} ${maliv} mali version"
    cd - > /dev/null
  fi

  if [ ! -e ${KDIR}/drivers/gpu/arm/mali400/ump/.version ]; then
    cp -p ${malil}/driver/src/devicedrv/ump/.version ${KDIR}/drivers/gpu/arm/mali400/ump/
    cd ${KDIR}
    git add drivers/gpu/arm/mali400/ump/.version
    git commit -m "drm: add ${malim} ${malis} ${maliv} ump version"
    cd - > /dev/null
  fi
fi

if [ -e mali450-${malis} ]; then
  if [ ! -e ${malim}-${malis} ]; then
    mkdir ${malim}-${malis}
    cp -apP mali450-${malis}/DEBIAN ${malim}-${malis}/
    sed -i s/mali450-${malis}/${malim}-${malis}/g ${malim}-${malis}/DEBIAN/control
  fi
fi

sed -i s/'^malia=.*'/'malia='${malia}/g build-mali-driver.sh
sed -i s/'^malil=.*'/'malil='${malil}/g build-mali-driver.sh
sed -i s/'^malim=.*'/'malim='${malim}/g build-mali-driver.sh
sed -i s/'^malis=.*'/'malis='${malis}/g build-mali-driver.sh
sed -i s/'^maliv=.*'/'maliv='${maliv}/g build-mali-driver.sh

echo OK
